// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "MyApp.h"

#include "MainFrm.h"
#include "Page1.h" 
#include "Page2.h"
#include "TimerDialog.h"
#include <afxmt.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

class CTimer 
{
  protected: 
    CTime m_time;
    CCriticalSection m_CS;
  public:
    CWinThread *m_thread;
    CTimer()  {Reset();}
    CTime GetTime();
    void    SetTime(CTime time);
    void   Reset()     {
         m_time = CTime::GetCurrentTime();
         m_thread = NULL; } 
};

CTime CTimer::GetTime() 
{
  CSingleLock csl(&m_CS);
  csl.Lock();
  CTime time= m_time;
  csl.Unlock();
  return time; 
}

void CTimer::SetTime(CTime time) 
{
  CSingleLock csl(&m_CS);
  csl.Lock();
  m_time = time;
  csl.Unlock(); 
}


CTimer g_timer;

UINT DoTimer(LPVOID pparam)
{
  CTime currenttime = CTime::GetCurrentTime(); 
  while(currenttime < g_timer.GetTime())
  {
    Sleep(1000);
    currenttime = CTime::GetCurrentTime();
  }
  AfxMessageBox("Time's up!"); 
  g_timer.Reset();
  return 0; 
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_VIEW_SETTINGS, OnViewSettings)
	ON_COMMAND(ID_VIEW_TIMER, OnViewTimer)
	ON_COMMAND(ID_HELP_HELPTOPICS, OnHelpHelptopics)
	//}}AFX_MSG_MAP
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_DB, OnUpdateDB)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_DB,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnUpdateDB(CCmdUI *pCmdUI) 
{
  CMyAppApp * pApp = dynamic_cast<CMyAppApp *>(AfxGetApp());
  ASSERT_VALID(pApp);

  if (pApp->m_isDatabaseConnected)
    pCmdUI->SetText("Connected to: "+ pApp->m_strDSN);
  else
    pCmdUI->SetText("Database not connected"); 
}

void CMainFrame::OnViewSettings() 
{
  CPropertySheet PropSheet; 
  CPage1 pp1; 
  CPage2 pp2;

  PropSheet.AddPage(&pp1); 
  PropSheet.AddPage(&pp2);
  PropSheet.SetTitle("MyApp Settings"); 
  PropSheet.DoModal();
	
}

void CMainFrame::OnViewTimer() 
{
  CTimerDialog aTDlg;
  aTDlg.m_settime = g_timer.GetTime();
  if (aTDlg. DoModal() == IDOK)
  {
    g_timer.SetTime(aTDlg.m_settime);
    // Only one timer running per instance 
    if(!g_timer.m_thread)
      g_timer.m_thread = AfxBeginThread(DoTimer, 0); 
  }
}

void CMainFrame::OnHelpHelptopics() 
{
	// TODO: Add your command handler code here
  ::HtmlHelp(NULL, 
  "G:\\Arkady\\Site\\Works\\VC\\MyApp\\hlp\\MyHHelp.chm", 
  HH_DISPLAY_TOPIC, 0);	
}
